﻿using Spire.Xls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace InvoiceGenerator
{
    public partial class Form1 : Form
    {
		static Workbook workbook;
		static int count = 1;
		int sheetcount = 1;
		Worksheet currentSheet;
		int maxRowCount = 25;
        int rowStart = 0;
        public Form1()
        {
            InitializeComponent();
			workbook = new Workbook();
			workbook.Worksheets.Clear();
			Worksheet sheet = workbook.Worksheets.Add("sheet" + sheetcount++);
			currentSheet = sheet;
			
		}

		private void InvoiceTemplate(Worksheet sheet)
		{

			currentSheet.PageSetup.TopMargin = 0.5;
			currentSheet.PageSetup.BottomMargin = 0.5;
			currentSheet.PageSetup.LeftMargin = 0.3;
			currentSheet.PageSetup.RightMargin = 0.3;

			currentSheet.PageSetup.HeaderMarginInch = 0.3;
			currentSheet.PageSetup.FooterMarginInch = 0.3;

			currentSheet.Range["J52:J53"].Borders[BordersLineType.EdgeLeft].LineStyle = LineStyleType.Thin;
			currentSheet.Range["J53:J53"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Double;
			currentSheet.Range["A2:A60"].Borders[BordersLineType.EdgeLeft].LineStyle = LineStyleType.Thin;
			currentSheet.Range["J2:J60"].Borders[BordersLineType.EdgeRight].LineStyle = LineStyleType.Thin;
			currentSheet.Range["G2:G3"].Borders[BordersLineType.EdgeRight].LineStyle = LineStyleType.Thin;
			currentSheet.Range["G12:G13"].Borders[BordersLineType.EdgeRight].LineStyle = LineStyleType.Thin;
			currentSheet.Range["G22:G51"].Borders[BordersLineType.EdgeRight].LineStyle = LineStyleType.Thin;
			currentSheet.Range["H22:H51"].Borders[BordersLineType.EdgeRight].LineStyle = LineStyleType.Thin;
			currentSheet.Range["I22:I51"].Borders[BordersLineType.EdgeRight].LineStyle = LineStyleType.Thin;
			currentSheet.Range["D2:D21"].Borders[BordersLineType.EdgeRight].LineStyle = LineStyleType.Thin;
			currentSheet.Range["B15:B21"].Borders[BordersLineType.EdgeRight].LineStyle = LineStyleType.Thin;
			currentSheet.Range["E3:J3"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["E5:J5"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["E7:J7"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["E11:J11"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["E13:J13"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["A21:J21"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["A7:D7"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["A14:D14"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["A16:D16"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["A18:D18"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["D2:D21"].Borders[BordersLineType.EdgeRight].LineStyle = LineStyleType.Thin;
			currentSheet.Range["A52:J52"].Borders[BordersLineType.EdgeTop].LineStyle = LineStyleType.Thin;
			currentSheet.Range["A60:J60"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;
			currentSheet.Range["G55:J55"].Borders[BordersLineType.EdgeTop].LineStyle = LineStyleType.Thin;
			currentSheet.Range["G55:G60"].Borders[BordersLineType.EdgeLeft].LineStyle = LineStyleType.Thin;

			currentSheet.Range["J52:J53"].Merge();

			currentSheet.Range["A1:J1"].Merge();
			sheet.SetRowHeight(1, 17.25);
			currentSheet.Range["A1"].Text = "INVOICE";
			currentSheet.Range["A1"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A1"].Style.Font.Size = 11;
			currentSheet.Range["A1"].Style.Font.IsBold = true;
			currentSheet.Range["A1"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A1"].Style.HorizontalAlignment = HorizontalAlignType.Center;
			currentSheet.Range["A1:J1"].Borders[BordersLineType.EdgeBottom].LineStyle = LineStyleType.Thin;

			currentSheet.Range["A3:D3"].Merge();
			currentSheet.Range["A3"].Text = "RALSONS DORMA PRIVATE LIMITED";
			currentSheet.Range["A3"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A3"].Style.Font.Size = 10;
			currentSheet.Range["A3"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A3"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A4:D7"].Merge();
			currentSheet.Range["A4"].Text = "31/S/7, YO-HIC-SINH PARANI,\r\nSILPARA - 700 031, INDIA\r\nSTATE CODE:-19;  GSTIN NO. 99PAECL1620T1OD\r\nTEL : 00 91 44 2585 4270, FAX : 00 91 44 2585 4520";
			currentSheet.Range["A4"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A4"].Style.Font.Size = 9;
			currentSheet.Range["A4"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A4"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A2:D2"].Merge();
			currentSheet.Range["A2"].Text = "Exporter";
			currentSheet.Range["A2"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A2"].Style.Font.Size = 10;
			currentSheet.Range["A2"].Style.Font.IsBold = true;
			currentSheet.Range["A2"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A2"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["E2:G2"].Merge();
			currentSheet.Range["E2"].Text = "Invoice No. & Date";
			currentSheet.Range["E2"].Style.Font.FontName = "Cambria";
			currentSheet.Range["E2"].Style.Font.Size = 10;
			currentSheet.Range["E2"].Style.Font.IsBold = true;
			currentSheet.Range["E2"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["E2"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["H2:J2"].Merge();
			currentSheet.Range["H2"].Text = "Exporter's Ref.";
			currentSheet.Range["H2"].Style.Font.FontName = "Cambria";
			currentSheet.Range["H2"].Style.Font.Size = 10;
			currentSheet.Range["H2"].Style.Font.IsBold = true;
			currentSheet.Range["H2"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["H2"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["E4:J4"].Merge();
			currentSheet.Range["E4"].Text = "Buyer's Order No & Date";
			currentSheet.Range["E4"].Style.Font.FontName = "Cambria";
			currentSheet.Range["E4"].Style.Font.Size = 10;
			currentSheet.Range["E4"].Style.Font.IsBold = true;
			currentSheet.Range["E4"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["E4"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["E6:J6"].Merge();
			currentSheet.Range["E6"].Text = "Other Reference(s)";
			currentSheet.Range["E6"].Style.Font.FontName = "Cambria";
			currentSheet.Range["E6"].Style.Font.Size = 10;
			currentSheet.Range["E6"].Style.Font.IsBold = true;
			currentSheet.Range["E6"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["E6"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A8:D8"].Merge();
			currentSheet.Range["A8"].Text = "Consignee";
			currentSheet.Range["A8"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A8"].Style.Font.Size = 10;
			currentSheet.Range["A8"].Style.Font.IsBold = true;
			currentSheet.Range["A8"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A8"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["E8:J8"].Merge();
			currentSheet.Range["E8"].Text = "Buyer (if other than consignee)";
			currentSheet.Range["E8"].Style.Font.FontName = "Cambria";
			currentSheet.Range["E8"].Style.Font.Size = 10;
			currentSheet.Range["E8"].Style.Font.IsBold = true;
			currentSheet.Range["E8"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["E8"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["E12:G12"].Merge();
			currentSheet.Range["E12"].Text = "Country of Origin of Goods";
			currentSheet.Range["E12"].Style.Font.FontName = "Cambria";
			currentSheet.Range["E12"].Style.Font.Size = 10;
			currentSheet.Range["E12"].Style.Font.IsBold = true;
			currentSheet.Range["E12"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["E12"].Style.HorizontalAlignment = HorizontalAlignType.Center;

			currentSheet.Range["H12:J12"].Merge();
			currentSheet.Range["H12"].Text = "Country of Final Destination";
			currentSheet.Range["H12"].Style.Font.FontName = "Cambria";
			currentSheet.Range["H12"].Style.Font.Size = 10;
			currentSheet.Range["H12"].Style.Font.IsBold = true;
			currentSheet.Range["H12"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["H12"].Style.HorizontalAlignment = HorizontalAlignType.Center;

			currentSheet.Range["E14:J14"].Merge();
			currentSheet.Range["E14"].Text = "Terms of Delivery and Payment";
			currentSheet.Range["E14"].Style.Font.FontName = "Cambria";
			currentSheet.Range["E14"].Style.Font.Size = 10;
			currentSheet.Range["E14"].Style.Font.IsBold = true;
			currentSheet.Range["E14"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["E14"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A15:B15"].Merge();
			currentSheet.Range["A15"].Text = "Pre Carriage by";
			currentSheet.Range["A15"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A15"].Style.Font.Size = 10;
			currentSheet.Range["A15"].Style.Font.IsBold = true;
			currentSheet.Range["A15"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A15"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["C15:D16"].Merge();
			currentSheet.Range["C15"].Text = "Place of Receipt by Pre-Carrier";
			currentSheet.Range["C15"].Style.Font.FontName = "Cambria";
			currentSheet.Range["C15"].Style.Font.Size = 8;
			currentSheet.Range["C15"].Style.Font.IsBold = true;
			currentSheet.Range["C15"].Style.VerticalAlignment = VerticalAlignType.Top;
			currentSheet.Range["C15"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A17:B17"].Merge();
			currentSheet.Range["A17"].Text = "Vessel / Flight No.";
			currentSheet.Range["A17"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A17"].Style.Font.Size = 10;
			currentSheet.Range["A17"].Style.Font.IsBold = true;
			currentSheet.Range["A17"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A17"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["C17:D17"].Merge();
			currentSheet.Range["C17"].Text = "Port of Loading";
			currentSheet.Range["C17"].Style.Font.FontName = "Cambria";
			currentSheet.Range["C17"].Style.Font.Size = 10;
			currentSheet.Range["C17"].Style.Font.IsBold = true;
			currentSheet.Range["C17"].Style.VerticalAlignment = VerticalAlignType.Top;
			currentSheet.Range["C17"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["E18"].Text = "PAYMENT :";
			currentSheet.Range["E18"].Style.Font.FontName = "Cambria";
			currentSheet.Range["E18"].Style.Font.Size = 10;
			currentSheet.Range["E18"].Style.Font.IsBold = true;
			currentSheet.Range["E18"].Style.VerticalAlignment = VerticalAlignType.Top;
			currentSheet.Range["E18"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A19:B19"].Merge();
			currentSheet.Range["A19"].Text = "Port of Discharge";
			currentSheet.Range["A19"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A19"].Style.Font.Size = 10;
			currentSheet.Range["A19"].Style.Font.IsBold = true;
			currentSheet.Range["A19"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A19"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["C19:D19"].Merge();
			currentSheet.Range["C19"].Text = "Final Destination";
			currentSheet.Range["C19"].Style.Font.FontName = "Cambria";
			currentSheet.Range["C19"].Style.Font.Size = 10;
			currentSheet.Range["C19"].Style.Font.IsBold = true;
			currentSheet.Range["C19"].Style.VerticalAlignment = VerticalAlignType.Top;
			currentSheet.Range["C19"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A20:B21"].Merge();
			currentSheet.Range["C20:D21"].Merge();
			currentSheet.Range["A22:B23"].Merge();
			currentSheet.Range["A22"].Text = "Marks & Nos./\r\nContainer No.";
			currentSheet.Range["A22"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A22"].Style.Font.Size = 11;
			currentSheet.Range["A22"].Style.Font.IsBold = true;
			currentSheet.Range["A22"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A22"].Style.HorizontalAlignment = HorizontalAlignType.Center;

			currentSheet.Range["C22:D23"].Merge();
			currentSheet.Range["C22"].Text = "No. & Kind of Pkgs.";
			currentSheet.Range["C22"].Style.Font.FontName = "Cambria";
			currentSheet.Range["C22"].Style.Font.Size = 11;
			currentSheet.Range["C22"].Style.Font.IsBold = true;
			currentSheet.Range["C22"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["C22"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["E22:G23"].Merge();
			currentSheet.Range["E22"].Text = "Description of Goods";
			currentSheet.Range["E22"].Style.Font.FontName = "Cambria";
			currentSheet.Range["E22"].Style.Font.Size = 11;
			currentSheet.Range["E22"].Style.Font.IsBold = true;
			currentSheet.Range["E22"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["E22"].Style.HorizontalAlignment = HorizontalAlignType.Center;

			currentSheet.Range["E24:G24"].Merge();
			currentSheet.Range["E24"].Text = "SKIN CARE PRODUCTS";
			currentSheet.Range["E24"].Style.Font.FontName = "Cambria";
			currentSheet.Range["E24"].Style.Font.Size = 12;
			currentSheet.Range["E24"].Style.Font.IsBold = true;
			currentSheet.Range["E24"].Style.Font.Underline = FontUnderlineType.Single;
			currentSheet.Range["E24"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["E24"].Style.HorizontalAlignment = HorizontalAlignType.Center;

			currentSheet.Range["H22:H23"].Merge();
			currentSheet.Range["H22"].Text = "Quantity";
			currentSheet.Range["H22"].Style.Font.FontName = "Cambria";
			currentSheet.Range["H22"].Style.Font.Size = 11;
			currentSheet.Range["H22"].Style.Font.IsBold = true;
			currentSheet.Range["H22"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["H22"].Style.HorizontalAlignment = HorizontalAlignType.Center;

			currentSheet.Range["I22"].Text = "Rate";
			currentSheet.Range["I22"].Style.Font.FontName = "Cambria";
			currentSheet.Range["I22"].Style.Font.Size = 10;
			currentSheet.Range["I22"].Style.Font.IsBold = true;
			currentSheet.Range["I22"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["I22"].Style.HorizontalAlignment = HorizontalAlignType.Center;

			currentSheet.Range["J22"].Text = "Amount";
			currentSheet.Range["J22"].Style.Font.FontName = "Cambria";
			currentSheet.Range["J22"].Style.Font.Size = 10;
			currentSheet.Range["J22"].Style.Font.IsBold = true;
			currentSheet.Range["J22"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["J22"].Style.HorizontalAlignment = HorizontalAlignType.Center;

			currentSheet.Range["I23:J23"].Merge();
			currentSheet.Range["I23"].Text = "U.S.DOLLARS";
			currentSheet.Range["I23"].Style.Font.FontName = "Cambria";
			currentSheet.Range["I23"].Style.Font.Size = 10;
			currentSheet.Range["I23"].Style.Font.IsBold = true;
			currentSheet.Range["I23"].Style.Font.Underline = FontUnderlineType.Single;
			currentSheet.Range["I23"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["I23"].Style.HorizontalAlignment = HorizontalAlignType.Center;

			//LAST LINES
			currentSheet.Range["A52"].Text = "Amount Chargeable";
			currentSheet.Range["A52"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A52"].Style.Font.Size = 10;
			currentSheet.Range["A52"].Style.Font.IsBold = true;
			currentSheet.Range["A52"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A52"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A53"].Text = "(in words)";
			currentSheet.Range["A53"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A53"].Style.Font.Size = 10;
			currentSheet.Range["A53"].Style.Font.IsBold = true;
			currentSheet.Range["A53"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A53"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A54"].Text = "I.E. CODE NO.0200008602";
			currentSheet.Range["A54"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A54"].Style.Font.Size = 10;
			currentSheet.Range["A54"].Style.Font.IsBold = true;
			currentSheet.Range["A54"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A54"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["G55"].Text = "Signature & Date";
			currentSheet.Range["G55"].Style.Font.FontName = "Cambria";
			currentSheet.Range["G55"].Style.Font.Size = 10;
			currentSheet.Range["G55"].Style.Font.IsBold = true;
			currentSheet.Range["G55"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["G55"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A57"].Text = "Declaration :";
			currentSheet.Range["A57"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A57"].Style.Font.Size = 10;
			currentSheet.Range["A57"].Style.Font.IsBold = true;
			currentSheet.Range["A57"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A57"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A58"].Text = "We declare that this Invoice shows the actual price of the";
			currentSheet.Range["A58"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A58"].Style.Font.Size = 10;
			currentSheet.Range["A58"].Style.Font.IsBold = true;
			currentSheet.Range["A58"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A58"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.Range["A59"].Text = "goods described that all particulars are true and correct";
			currentSheet.Range["A59"].Style.Font.FontName = "Cambria";
			currentSheet.Range["A59"].Style.Font.Size = 10;
			currentSheet.Range["A59"].Style.Font.IsBold = true;
			currentSheet.Range["A59"].Style.VerticalAlignment = VerticalAlignType.Center;
			currentSheet.Range["A59"].Style.HorizontalAlignment = HorizontalAlignType.Left;

			currentSheet.SetColumnWidth(1, 11.57);
			currentSheet.SetColumnWidth(2, 7.57);
			currentSheet.SetColumnWidth(3, 9.71);
			currentSheet.SetColumnWidth(4, 12.43);
			currentSheet.SetColumnWidth(5, 10.57);
			currentSheet.SetColumnWidth(6, 7.29);
			currentSheet.SetColumnWidth(7, 9.43);
			currentSheet.SetColumnWidth(8, 7.57);
			currentSheet.SetColumnWidth(9, 7);
			currentSheet.SetColumnWidth(10, 11.72);

			//Invoice No. & Date

			currentSheet.Range["E3:G3"].Merge();
			currentSheet.Range["E3"].Text = this.textBox1.Text;
			//Exporter's Ref.

			currentSheet.Range["H3:K3"].Merge();
			currentSheet.Range["H3"].Text = this.textBox1.Text;
			//Buyer's Order No & Date

			currentSheet.Range["E5:H5"].Merge();
			currentSheet.Range["E5"].Text = this.textBox1.Text;
			//Country of Origin of Goods

			currentSheet.Range["E13:G13"].Merge();
			currentSheet.Range["E13"].Text = this.textBox1.Text;
			//Country of Final Destination

			currentSheet.Range["H13:K13"].Merge();
			currentSheet.Range["H13"].Text = this.textBox1.Text;
			//Terms of Delivery and Payment

			currentSheet.Range["E16:F16"].Merge();
			currentSheet.Range["E16"].Text = this.textBox1.Text;

		}

		private void button1_Click(object sender, EventArgs e)
        {
			//add items to list box 1 and list box 2 after combo box 1 and combo box 2 are selected
			Worksheet targetWorksheet = workbook.Worksheets[0];
			for (int i= 1; i< workbook.Worksheets.Count; i++)
			{
				Worksheet srcWorksheet = workbook.Worksheets[i];
				int lastRow = targetWorksheet.LastRow;

				//Copy the first worksheet of source Excel document to the new added worksheet of target Excel document
				srcWorksheet.CopyRow(srcWorksheet.Range[1, 1, srcWorksheet.LastRow, srcWorksheet.LastColumn], targetWorksheet, targetWorksheet.LastRow + 2, CopyRangeOptions.All);
                workbook.Worksheets.Remove(srcWorksheet);
                i--;
			}

			String result = @"../../../Result-MergeCells.xlsx";
			workbook.SaveToFile(result, ExcelVersion.Version2013);
		}

        private void button2_Click(object sender, EventArgs e)
        {
			this.Close();
		}

        private void Form1_Activated(object sender, EventArgs e)
        {
			Workbook workbook = new Workbook();
			workbook.LoadFromFile(@"products.xlsx");
			Worksheet sheet = workbook.Worksheets[0];

			CellRange[] items = sheet.Columns[0].Cells;

			foreach (CellRange item in items)
			{
				if (!String.IsNullOrEmpty(item.Value2.ToString()))
				{
					comboBox1.Items.Add(item.Value);
				}

			}
			textBox1.Focus();
		}

        private void button3_Click(object sender, EventArgs e)
        {
			this.listBox2.Items.Add(comboBox2.Text);
			this.listBox1.Items.Add(comboBox1.Text);
			InvoiceTemplate(currentSheet);
			CellRange[] cellRanges = currentSheet.FindAllString("SKIN CARE PRODUCTS", false, false);
			foreach (CellRange range in cellRanges)
			{
				int rowIndex = range.Row;//25
				rowStart = rowIndex;
				int comboBox1Num = this.listBox1.Items.Count;

				if (range != null)
				{
					for (int i = 0; i < comboBox1Num; i++)
					{
						string listBox2Str = this.listBox2.Items[i].ToString();
						int listBox2Num = int.Parse(listBox2Str);
						int rowCount = 1 + 3 * listBox2Num;
						if (rowStart + rowCount > rowIndex + maxRowCount)
						{
							rowStart = rowIndex;
							currentSheet = workbook.Worksheets.Add("sheet" + sheetcount++);
							InvoiceTemplate(currentSheet);
						}
						rowStart++;
						currentSheet.Range[rowStart++, 5].Text =this.listBox1.Items[i].ToString();

						for (int j = 0; j < listBox2Num; j++)
						{
							currentSheet.Range[rowStart++, 5].Text = "Batch No.";
							currentSheet.Range[rowStart++, 5].Text = "DATE OF MFG.";
							currentSheet.Range[rowStart++, 5].Text = " ";
						}
						//rowIndex += rowCount;
					}
					


				}
            }
			count++;
		}



		
		private void textBox1_TextChanged(object sender, EventArgs e)
		//Invoice No. & Date
		{
		}

        private void textBox2_TextChanged(object sender, EventArgs e)
		//Exporter's Ref.
		{
		}

        private void textBox3_TextChanged(object sender, EventArgs e)
		//Buyer's Order No & Date
		{
		}

        private void textBox4_TextChanged(object sender, EventArgs e)
		//Country of Origin of Goods
		{
		}

        private void textBox5_TextChanged(object sender, EventArgs e)
		//Country of Final Destination
		{
		}

        private void textBox6_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox7_TextChanged(object sender, EventArgs e)
		//Terms of Delivery and Payment
		{
			currentSheet.Range["E16:F16"].Merge();
			currentSheet.Range["E16"].Text = this.textBox1.Text;
		}

    }
}
